#include "sh.h"

/*
 * Table for determining type of character.
 * NIGEL: In addition to changing the table to use symbolic constants rather
 * than magic octal values, I have removed the MSVAR category from use; the
 * one place where this category was used was equally-well served by strchr ()
 * and a spare bit is going to be needed for planned lexer improvements.
 */
unsigned char lextab[] ={
	/* EOF */        MNQUO | MDQUO | MNAME,
	/* 0x00, ^@ */   0,
	/* 0x01, ^A */   0,
	/* 0x02, ^B */   0,
	/* 0x03, ^C */   0,
	/* 0x04, ^D */   0,
	/* 0x05, ^E */   0,
	/* 0x06, ^F */   0,
	/* 0x07, ^G */   0,
	/* 0x08, ^H */   0,
	/* 0x09, ^I */   MNQUO | MNAME,
	/* 0x0a, ^J */   MNQUO | MDQUO | MNAME,
	/* 0x0b, ^K */   0,
	/* 0x0c, ^L */   0,
	/* 0x0d, ^M */   0,
	/* 0x0e, ^N */   0,
	/* 0x0f, ^O */   0,
	/* 0x10, ^P */   0,
	/* 0x11, ^Q */   0,
	/* 0x12, ^R */   0,
	/* 0x13, ^S */   0,
	/* 0x14, ^T */   0,
	/* 0x15, ^U */   0,
	/* 0x16, ^V */   0,
	/* 0x17, ^W */   0,
	/* 0x18, ^X */   0,
	/* 0x19, ^Y */   0,
	/* 0x1a, ^Z */   0,
	/* 0x1b, ^[ */   0,
	/* 0x1c, ^\ */   0,
	/* 0x1d, ^] */   0,
	/* 0x1e, ^^ */   0,
	/* 0x1f, ^_ */   0,
	/* 0x20, ' ' */  MNQUO | MNAME,
	/* 0x21, '!' */  0,
	/* 0x22, '"' */  MNQUO | MDQUO,
	/* 0x23, '#' */  0,
	/* 0x24, '$' */  MNQUO | MDQUO | MHERE,
	/* 0x25, '%' */  0,
	/* 0x26, '&' */  MNQUO | MNAME,
	/* 0x27, ''' */  MNQUO,
	/* 0x28, '(' */  MNQUO | MNAME,
	/* 0x29, ')' */  MNQUO | MNAME,
	/* 0x2a, '*' */  MGLOB,
	/* 0x2b, '+' */  0,
	/* 0x2c, ',' */  0,
	/* 0x2d, '-' */  0,
	/* 0x2e, '.' */  0,
	/* 0x2f, '/' */  0,
	/* 0x30, '0' */  MDIGI,
	/* 0x31, '1' */  MDIGI,
	/* 0x32, '2' */  MDIGI,
	/* 0x33, '3' */  MDIGI,
	/* 0x34, '4' */  MDIGI,
	/* 0x35, '5' */  MDIGI,
	/* 0x36, '6' */  MDIGI,
	/* 0x37, '7' */  MDIGI,
	/* 0x38, '8' */  MDIGI,
	/* 0x39, '9' */  MDIGI,
	/* 0x3a, ':' */  0,
	/* 0x3b, ';' */  MNQUO | MNAME,
	/* 0x3c, '<' */  MNQUO | MNAME,
	/* 0x3d, '=' */  0,
	/* 0x3e, '>' */  MNQUO | MNAME,
	/* 0x3f, '?' */  MGLOB,
	/* 0x40, '@' */  0,
	/* 0x41, 'A' */  MBVAR,
	/* 0x42, 'B' */  MBVAR,
	/* 0x43, 'C' */  MBVAR,
	/* 0x44, 'D' */  MBVAR,
	/* 0x45, 'E' */  MBVAR,
	/* 0x46, 'F' */  MBVAR,
	/* 0x47, 'G' */  MBVAR,
	/* 0x48, 'H' */  MBVAR,
	/* 0x49, 'I' */  MBVAR,
	/* 0x4a, 'J' */  MBVAR,
	/* 0x4b, 'K' */  MBVAR,
	/* 0x4c, 'L' */  MBVAR,
	/* 0x4d, 'M' */  MBVAR,
	/* 0x4e, 'N' */  MBVAR,
	/* 0x4f, 'O' */  MBVAR,
	/* 0x50, 'P' */  MBVAR,
	/* 0x51, 'Q' */  MBVAR,
	/* 0x52, 'R' */  MBVAR,
	/* 0x53, 'S' */  MBVAR,
	/* 0x54, 'T' */  MBVAR,
	/* 0x55, 'U' */  MBVAR,
	/* 0x56, 'V' */  MBVAR,
	/* 0x57, 'W' */  MBVAR,
	/* 0x58, 'X' */  MBVAR,
	/* 0x59, 'Y' */  MBVAR,
	/* 0x5a, 'Z' */  MBVAR,
	/* 0x5b, '[' */  MGLOB,
	/* 0x5c, '\' */  MNQUO | MDQUO | MHERE,
	/* 0x5d, ']' */  MGLOB,
	/* 0x5e, '^' */  0,
	/* 0x5f, '_' */  MBVAR,
	/* 0x60, '`' */  MNQUO | MDQUO | MHERE,
	/* 0x61, 'a' */  MBVAR,
	/* 0x62, 'b' */  MBVAR,
	/* 0x63, 'c' */  MBVAR,
	/* 0x64, 'd' */  MBVAR,
	/* 0x65, 'e' */  MBVAR,
	/* 0x66, 'f' */  MBVAR,
	/* 0x67, 'g' */  MBVAR,
	/* 0x68, 'h' */  MBVAR,
	/* 0x69, 'i' */  MBVAR,
	/* 0x6a, 'j' */  MBVAR,
	/* 0x6b, 'k' */  MBVAR,
	/* 0x6c, 'l' */  MBVAR,
	/* 0x6d, 'm' */  MBVAR,
	/* 0x6e, 'n' */  MBVAR,
	/* 0x6f, 'o' */  MBVAR,
	/* 0x70, 'p' */  MBVAR,
	/* 0x71, 'q' */  MBVAR,
	/* 0x72, 'r' */  MBVAR,
	/* 0x73, 's' */  MBVAR,
	/* 0x74, 't' */  MBVAR,
	/* 0x75, 'u' */  MBVAR,
	/* 0x76, 'v' */  MBVAR,
	/* 0x77, 'w' */  MBVAR,
	/* 0x78, 'x' */  MBVAR,
	/* 0x79, 'y' */  MBVAR,
	/* 0x7a, 'z' */  MBVAR,
	/* 0x7b, '{' */  0,
	/* 0x7c, '|' */  MNQUO | MNAME,
	/* 0x7d, '}' */  0,
	/* 0x7e, '~' */  0,
	/* 0x7f */       0
};
