/*
 * Emacs command tables.
 * Generated by ext.c
 * Make any changes by changing ext.c
 */

#include "stdio.h"
#include "ed.h"

extern            ctrlg();	/* Abort out of things		*/
extern             quit();	/* Quit				*/
extern           ctlxlp();	/* Begin macro			*/
extern           ctlxrp();	/* End macro			*/
extern            ctlxe();	/* Execute macro		*/
extern         fileread();	/* Get a file, read only	*/
extern        filevisit();	/* Get a file, read write	*/
				/* Also F2 */
extern        filewrite();	/* Write a file			*/
				/* Also F2 */
extern         filesave();	/* Save current file		*/
extern         filename();	/* Adjust file name		*/
extern          gotobol();	/* Move to start of line	*/
				/* Also HOME KEY */
extern         forwchar();	/* Move forward by characters	*/
				/* Also RIGHT ARROW */
extern          gotoeol();	/* Move to end of line		*/
				/* Also END KEY */
extern         backchar();	/* Move backward by characters	*/
				/* Also LEFT ARROW */
extern         forwline();	/* Move forward by lines	*/
				/* Also DOWN ARROW */
extern         backline();	/* Move backward by lines	*/
				/* Also UP ARROW */
extern         forwpage();	/* Move forward by pages	*/
				/* Also PAGE DOWN */
extern         backpage();	/* Move backward by pages	*/
				/* Also PAGE UP */
extern          gotobob();	/* Move to start of buffer	*/
extern          gotoeob();	/* Move to end of buffer	*/
extern       setfillcol();	/* Set fill column to current col */
				/* ctl-u n set fill col to n	*/
				/* ctl-u 0 turn off word wrap	*/
extern       fillregion();	/* apply fillcol to a region*/
extern          setmark();	/* Set mark			*/
extern         swapmark();	/* Swap '.' and mark		*/
extern       forwsearch();	/* Search forward		*/
				/* Also F3 */
				/* ALT F3 is continue search */
extern      forwisearch();	/* forward incremental search	*/
extern      backisearch();	/* backward incremental search	*/
extern        queryrepl();	/* query/replace		*/
				/* Also F5 */
extern      searchagain();	/* find next occurrance		*/
extern       backsearch();	/* Search backwards		*/
				/* Also F4 */
extern         showcpos();	/* Show the cursor position	*/
extern         nextwind();	/* Move to the next window	*/
				/* Also F6 */
extern         prevwind();	/* Move to the previous window	*/
extern         onlywind();	/* Make current window only one	*/
				/* Also F10 */
extern        splitwind();	/* Split current window		*/
				/* Also ALT F1 */
extern         mvdnwind();	/* Move window down		*/
extern         mvupwind();	/* Move window up		*/
extern      enlargewind();	/* Enlarge display window.	*/
extern       shrinkwind();	/* Shrink window.		*/
extern      listbuffers();	/* Display list of buffers	*/
extern        usebuffer();	/* Switch a window to a buffer	*/
extern       killbuffer();	/* Make a buffer go away.	*/
extern       reposition();	/* Reposition dot to line ctl-u	*/
				/* if ctl-u 0 center		*/
				/* if ctl-u < 0 repos from bottom */
extern          refresh();	/* Refresh the screen		*/
				/* with ctl-u recenter		*/
extern          twiddle();	/* Twiddle characters		*/
extern              tab();	/* Insert tab			*/
				/* ctl-u n  use n spaces per tab	*/
				/* ctl-u -n tab is n spaces	*/
extern          newline();	/* Insert CR-LF			*/
				/* Same as ctl-j in autoindent mode */
extern           indent();	/* Insert CR-LF, then indent	*/
extern         openline();	/* Open up a blank line		*/
extern          deblank();	/* Delete blank lines		*/
extern            quote();	/* Insert literal		*/
extern         quoteval();	/* Insert decimal literal        */
extern         backword();	/* Backup by words		*/
extern         forwword();	/* Advance by words		*/
extern          forwdel();	/* Forward delete		*/
				/* Also DELETE KEY */
extern          backdel();	/* Backward delete		*/
extern             kill();	/* Kill forward from dot		*/
				/* if ctl-u 0 or less backward	*/
extern             yank();	/* Yank back from killbuffer.	*/
extern        loadBinds();	/* Load flexable bindings from file. */
extern          nameMac();	/* Bind current macro to binding. */
extern          initMac();	/* Bind current macro to initial macro */
extern        setPrefix();	/* Set prefix codes		*/
extern          bindFun();	/* Bind function to old function. */
extern        storBinds();	/* Store flexable bindings on a file. */
extern        upperword();	/* Upper case word.		*/
extern        lowerword();	/* Lower case word.		*/
extern      upperregion();	/* Upper case region.		*/
extern      lowerregion();	/* Lower case region.		*/
extern          capword();	/* Initial capitalize word.	*/
extern         delfword();	/* Delete forward word.		*/
extern         delbword();	/* Delete backward word.	*/
extern       killregion();	/* Kill region.			*/
extern       copyregion();	/* Copy region to kill buffer.	*/
extern         spawncli();	/* Run CLI in a subjob.		*/
extern            spawn();	/* Run a command in a subjob.	*/
extern        quickexit();	/* low keystroke style exit.	*/
extern         gotoline();	/* goto line given as arg	*/
extern        gotofline();	/* goto line in file.		*/
extern          setfold();	/* set case-fold on search flag	*/
extern       displaymod();	/* toggle display mode switch   */
extern          autoind();	/* toggle autoindent flag       */
				/* Also ALT F10 */
extern          nexterr();	/* Seek the next error		*/
extern          preverr();	/* Seek the previous error	*/
extern    bracketsearch();	/* seek matching bracket char	*/
extern        bracketsw();	/* toggle bracket mode		*/
extern       lookupword();	/* Lookup a word...		*/
				/* Also F1 */
extern       promptlook();	/* Prompt for a word to look up	*/
extern          zaphelp();	/* Zap help window		*/
extern         hlpindex();	/* Help index generator		*/
extern          zapwind();	/* Zap current window		*/

FUNTAB funtab[] = {
           ctrlg,	/* 0 */
            quit,	/* 1 */
          ctlxlp,	/* 2 */
          ctlxrp,	/* 3 */
           ctlxe,	/* 4 */
        fileread,	/* 5 */
       filevisit,	/* 6 */
       filewrite,	/* 7 */
        filesave,	/* 8 */
        filename,	/* 9 */
         gotobol,	/* 10 */
        forwchar,	/* 11 */
         gotoeol,	/* 12 */
        backchar,	/* 13 */
        forwline,	/* 14 */
        backline,	/* 15 */
        forwpage,	/* 16 */
        backpage,	/* 17 */
         gotobob,	/* 18 */
         gotoeob,	/* 19 */
      setfillcol,	/* 20 */
      fillregion,	/* 21 */
         setmark,	/* 22 */
        swapmark,	/* 23 */
      forwsearch,	/* 24 */
     forwisearch,	/* 25 */
     backisearch,	/* 26 */
       queryrepl,	/* 27 */
     searchagain,	/* 28 */
      backsearch,	/* 29 */
        showcpos,	/* 30 */
        nextwind,	/* 31 */
        prevwind,	/* 32 */
        onlywind,	/* 33 */
       splitwind,	/* 34 */
        mvdnwind,	/* 35 */
        mvupwind,	/* 36 */
     enlargewind,	/* 37 */
      shrinkwind,	/* 38 */
     listbuffers,	/* 39 */
       usebuffer,	/* 40 */
      killbuffer,	/* 41 */
      reposition,	/* 42 */
         refresh,	/* 43 */
         twiddle,	/* 44 */
             tab,	/* 45 */
         newline,	/* 46 */
          indent,	/* 47 */
        openline,	/* 48 */
         deblank,	/* 49 */
           quote,	/* 50 */
        quoteval,	/* 51 */
        backword,	/* 52 */
        forwword,	/* 53 */
         forwdel,	/* 54 */
         backdel,	/* 55 */
            kill,	/* 56 */
            yank,	/* 57 */
       loadBinds,	/* 58 */
         nameMac,	/* 59 */
         initMac,	/* 60 */
       setPrefix,	/* 61 */
         bindFun,	/* 62 */
       storBinds,	/* 63 */
       upperword,	/* 64 */
       lowerword,	/* 65 */
     upperregion,	/* 66 */
     lowerregion,	/* 67 */
         capword,	/* 68 */
        delfword,	/* 69 */
        delbword,	/* 70 */
      killregion,	/* 71 */
      copyregion,	/* 72 */
        spawncli,	/* 73 */
           spawn,	/* 74 */
       quickexit,	/* 75 */
        gotoline,	/* 76 */
       gotofline,	/* 77 */
         setfold,	/* 78 */
      displaymod,	/* 79 */
         autoind,	/* 80 */
         nexterr,	/* 81 */
         preverr,	/* 82 */
   bracketsearch,	/* 83 */
       bracketsw,	/* 84 */
      lookupword,	/* 85 */
      promptlook,	/* 86 */
         zaphelp,	/* 87 */
        hlpindex,	/* 88 */
         zapwind,	/* 89 */
};
KEYTAB keytab[] = {
{        CTRL|'H',  55,  65 },	/* backdel          0 */
{        CTRL|'I',  45,  78 },	/* tab              1 */
{        CTRL|'J',  47,  79 },	/* indent           2 */
{        CTRL|'K',  56,  44 },	/* kill             3 */
{        CTRL|'L',  43,  80 },	/* refresh          4 */
{        CTRL|'M',  46,  46 },	/* newline          5 */
{        CTRL|'N',  14,  45 },	/* forwline         6 */
{        CTRL|'O',  48,  47 },	/* openline         7 */
{        CTRL|'P',  15,  58 },	/* backline         8 */
{        CTRL|'Q',  50,  48 },	/* quote            9 */
{        CTRL|'R',  26,  49 },	/* backisearch      10 */
{        CTRL|'S',  25,  -1 },	/* forwisearch      11 */
{        CTRL|'T',  44,  50 },	/* twiddle          12 */
{   PFX1|CTRL|'V',   6,  -1 },	/* filevisit        13 */
{        CTRL|'V',  16,  51 },	/* forwpage         14 */
{        CTRL|'W',  71,  52 },	/* killregion       15 */
{        META|'%',  27,  -1 },	/* queryrepl        16 */
{        CTRL|'Y',  57,  53 },	/* yank             17 */
{        CTRL|'Z',  75,  54 },	/* quickexit        18 */
{        PFX1|'=',  30,  87 },	/* showcpos         19 */
{        PFX1|'>',  81,  70 },	/* nexterr          20 */
{        PFX1|'?',  86,  89 },	/* promptlook       21 */
{        META|'T',  79,  -1 },	/* displaymod       22 */
{        META|'U',  64,  -1 },	/* upperword        23 */
{        PFX1|'B',  40,  90 },	/* usebuffer        24 */
{        META|'.',  22,  91 },	/* setmark          25 */
{        META|'/',  28,  -1 },	/* searchagain      26 */
{        PFX1|'E',   4,  -1 },	/* ctlxe            27 */
{        PFX1|'F',  20,  74 },	/* setfillcol       28 */
{        PFX1|'G',  76,  75 },	/* gotoline         29 */
{        PFX1|'H',  21,  71 },	/* fillregion       30 */
{        PFX1|'I',  60,  -1 },	/* initMac          31 */
{        PFX1|'!',  74,  -1 },	/* spawn            32 */
{        CTRL|'@',  22,  59 },	/* setmark          33 */
{        CTRL|'A',  10,  41 },	/* gotobol          34 */
{        CTRL|'B',  13,  42 },	/* backchar         35 */
{        CTRL|'C',  73,  62 },	/* spawncli         36 */
{        CTRL|'D',  54,  -1 },	/* forwdel          37 */
{        CTRL|'E',  12,  43 },	/* gotoeol          38 */
{        CTRL|'F',  11,  55 },	/* forwchar         39 */
{        CTRL|'G',   0,  56 },	/* ctrlg            40 */
{   PFX1|CTRL|'B',  39,  60 },	/* listbuffers      41 */
{   PFX1|CTRL|'C',   1,  61 },	/* quit             42 */
{   PFX1|CTRL|'F',   9,  63 },	/* filename         43 */
{   PFX1|CTRL|'L',  67,  -1 },	/* lowerregion      44 */
{   PFX1|CTRL|'O',  49,  82 },	/* deblank          45 */
{   PFX1|CTRL|'N',  35,  66 },	/* mvdnwind         46 */
{   PFX1|CTRL|'P',  36,  57 },	/* mvupwind         47 */
{   PFX1|CTRL|'R',   5,  84 },	/* fileread         48 */
{   PFX1|CTRL|'S',   8,  69 },	/* filesave         49 */
{   PFX1|CTRL|'U',  66,  73 },	/* upperregion      50 */
{   PFX1|CTRL|'W',   7,  86 },	/* filewrite        51 */
{   PFX1|CTRL|'X',  23,  -1 },	/* swapmark         52 */
{   PFX1|CTRL|'Z',  38,  -1 },	/* shrinkwind       53 */
{        PFX1|'<',  82,  -1 },	/* preverr          54 */
{        PFX1|'(',   2,  77 },	/* ctlxlp           55 */
{        PFX1|')',   3,  64 },	/* ctlxrp           56 */
{        PFX1|'1',  33,  67 },	/* onlywind         57 */
{        PFX1|'2',  34,  68 },	/* splitwind        58 */
{        PFX1|'K',  41,  -1 },	/* killbuffer       59 */
{        PFX1|'L',  58,  -1 },	/* loadBinds        60 */
{        PFX1|'M',  59,  -1 },	/* nameMac          61 */
{        PFX1|'N',  31,  -1 },	/* nextwind         62 */
{        PFX1|'P',  32,  -1 },	/* prevwind         63 */
{        PFX1|'R',  62,  -1 },	/* bindFun          64 */
{        PFX1|'S',  63,  72 },	/* storBinds        65 */
{        PFX1|'X',  61,  81 },	/* setPrefix        66 */
{        PFX1|'Z',  37,  -1 },	/* enlargewind      67 */
{        PFX1|'[',  83,  83 },	/* bracketsearch    68 */
{        PFX1|']',  84,  -1 },	/* bracketsw        69 */
{   META|CTRL|'H',  70,  88 },	/* delbword         70 */
{   META|CTRL|'R',  27,  -1 },	/* queryrepl        71 */
{   META|CTRL|']',  88,  76 },	/* hlpindex         72 */
{        META|'!',  42,  85 },	/* reposition       73 */
{        META|'1',  89,  -1 },	/* zapwind          74 */
{        META|'2',  87,  -1 },	/* zaphelp          75 */
{        META|'>',  19,  -1 },	/* gotoeob          76 */
{        META|'<',  18,  -1 },	/* gotobob          77 */
{        META|'?',  85,  -1 },	/* lookupword       78 */
{        META|'@',  78,  -1 },	/* setfold          79 */
{        META|'B',  52,  93 },	/* backword         80 */
{        META|'C',  68,  -1 },	/* capword          81 */
{        META|'D',  69,  -1 },	/* delfword         82 */
{        META|'F',  53,  -1 },	/* forwword         83 */
{        META|'G',  77,  -1 },	/* gotofline        84 */
{        META|'J',  80,  -1 },	/* autoind          85 */
{        META|'L',  65,  -1 },	/* lowerword        86 */
{        META|'Q',  51,  -1 },	/* quoteval         87 */
{        META|'R',  29,  -1 },	/* backsearch       88 */
{        META|'S',  24,  -1 },	/* forwsearch       89 */
{        META|'V',  17,  92 },	/* backpage         90 */
{        META|'W',  72,  -1 },	/* copyregion       91 */
{       META|0x7F,  70,  -1 },	/* delbword         92 */
{            0x7F,  55,  -1 },	/* backdel          93 */
};
